<?php if (!defined('PmWiki')) exit();
/*
  PmWiki module to generate a form that allows you to send email to
  a person specified in the Wiki.
  Copyright (C) 2004  Nils Knappmeier <nk@knappi.org>
  This is GPL, only it seems odd to include a license in a programm
  that has twice the size of the license.

  Modifications to work with PmWiki 2.0, 
    Copyright (c) 2005 by Patrick R. Michaud <pmichaud@pobox.com>

  Modifications to align with PmWiki 2.0 conventions,
    Copyright (c) 2005 by John Rankin <john.rankin@affinity.co.nz>
*/

XLSDV('en', array(
  'MF' => '&nbsp;',
  'MFsuccess' => 'Message has been sent successfully',
  'MFfailure' => 'Message could not be sent',
  'MFnomail'  => 'Error: Mailto Address not found',
  'MFerror'   => 'An error occurred: no message text'));

$r = @$_REQUEST['mailform'];
$MailFormResult = FmtPageName("$[MF$r]", $pagename);

# This is the default form, as a table.  The address is hidden --
# the variables are straightforward $...Fmt substitutions.
SDV($MailFormFmt,"<form action='\$PageUrl'>
  <input type='hidden' name='n' value='\$FullName'>
  <input type='hidden' name='address' value='\$Address'>
  <input type='hidden' name='action' value='mailform'/>
  <input type='hidden' name='redirect' value='\$Redirect'/>
  <table><caption>\$MailFormResult</caption>
    <tr><td class='prompt'>$[Your Address:]</td>
      <td colspan='2'>
        <input type='text' size='\$Size' name='sender' value=''/></td></tr>
    <tr><td class='prompt'>$[Subject:]</td>
      <td colspan='2'>
        <input type='text' size='50' value='\$Subject' name='subject'/></td></tr>
    <tr><td class='prompt'>$[Message:]</td>
      <td colspan='2'>
        <textarea name='text' cols='50' rows='10'>\$Message</textarea></td></tr>
    <tr><td class='prompt'>$[Your Name:]</td>
      <td><input type='text' size='\$Size' name='author' value='\$Author'/></td>
      <td><input type='submit' name='send' value='\$Label'></td></tr>
      </table></form>");

# This defines the mailform: markup -- it's just a straight text substitution.
Markup('mailform', '>links', "/^mailform:([^\\W]+)/e",
  "'<:block>'.MakeMailForm(\$pagename, array('address' => '$1'),\$GLOBALS['MailFormFmt'])");

# This defines what happens after someone has submitted a message.
$HandleActions['mailform'] = 'HandleMailForm';

# Allow other scripts to call MakeMailForm with an actual email address
function IsEmailAddress($text) {
  global $UrlExcludeChars;
  $notAt = "[^@\\s$UrlExcludeChars]*[^@\\s.,?!$UrlExcludeChars]";
  return (preg_match("/^$notAt".'@'."$notAt$/",$text)) ? true : false;
}

# Generate the mail form from the mailform: markup
function MakeMailForm($pagename, $opt, $fmt) {
  global $FmtV, $MailBoxOpt, $MailFormFmt;
  SDVA($MailBoxOpt, array('size' => '30',
    'label'    => FmtPageName('$[Send]', $pagename),
    'redirect' => 'browse'
  ));
  $opt = array_merge((array)$MailBoxOpt, $opt, @$_REQUEST);
  $FmtV['$Size']    = @$opt['size'];
  $FmtV['$Address'] = @$opt['address'];
  $FmtV['$Subject'] = @$opt['subject'] . '';
  $FmtV['$Message'] = @$opt['message'] . '';
  $FmtV['$Label']   = @$opt['label'];
  $FmtV['$Redirect']= @$opt['redirect'];
  return FmtPageName($fmt, $pagename);
}

# The variables are the header and footer for the email message,
# HandleMailForm sends the message to the address in the page.
function HandleMailForm($pagename) {
  global $MailFormAddresses, $MailFormHeader, $MailFormFooter,
    $MailFormDefaultSender, $MailFormDefaultAuthor, $ScriptUrl;
  SDV($MailFormHeader,"");
  SDV($MailFormFooter,
    "\n-------------------------------------------\n"
   ."The PmWiki MailForm at $ScriptUrl sent this message.\n");
  SDV($MailFormDefaultSender,"");
  SDV($MailFormDefaultAuthor,"anonymous");

  $to = (IsEmailAddress($_REQUEST['address'])) ? $_REQUEST['address'] :
    @$MailFormAddresses[$_REQUEST['address']];
  $from = ($_REQUEST['sender']) ? $_REQUEST['sender'] : $MailFormDefaultSender;
  $subject = $_REQUEST['subject'];
  $author = "\n--\n" .
     (($_REQUEST['author']) ? $_REQUEST['author'] : $MailFormDefaultAuthor);
  $text = $MailFormHeader.stripmagic($_REQUEST['text']).$author.$MailFormFooter;
  if (!$_REQUEST['text']) $msg = 'error';
  elseif ($to)
     $msg = (mail($to, $subject, $text, "From: $from")) ? 'success' : 'failure';
  else $msg = 'nomail';
  $redirect = ($_REQUEST['redirect']) ? '&action='.$_REQUEST['redirect'] : '';
  Redirect($pagename,"\$PageUrl?mailform=$msg$redirect");
}

?>
